<ul class="breadcrumb">
    <li><a href="<?= $this->url('root') ?>"><i class="fa fa-home"></i></a></li>
    <li><a href="<?= $this->url('client') ?>"><?= $this->translate('client_module_title') ?></a></li>
    <li class="active"><?= $this->translate('client_nav_list') ?></li>
</ul>

<h1 class="page-title">
    <?= $this->icon('clients') ?> <?= $this->translate('client_module_title') ?>
</h1>

<div ng-controller="clientController as self">
    <div class="row row-padding">
        <div class="col-sm-3">
            <ul class="list-group">
                <li class="list-group-item">
                    <button class="btn" ng-click="self.resetClient()"><?= $this->translate('client_button_create_client') ?></button>
                </li>
                <li class="list-group-item">
                    <div class="input-group">
                        <input type="text" autocomplete="off" class="form-control" placeholder="<?= $this->translate('search', null, null, false) ?>"
                               ng-model="clientQuery" />
                        <span class="input-group-addon"><i class="fa fa-fw fa-search"></i></span>
                    </div>
                </li>
                <li class="list-group-item"
                    ng-repeat-start="(network, clients) in self.clients | filter:clientQuery | groupBy: 'network.name'">
                    <h4>
                        {{network === 'undefined' ? 'Sans réseau' : network}}
                    </h4>
                </li>
                <li ng-repeat-end
                    class="list-group-item pointer"
                    ng-repeat="client in clients | orderBy : '-master'"
                    ng-class="{active: self.client.id == client.id}"
                    ng-click="self.editClient(client)">
                    <a>
                        {{client.name}}
                        <i ng-if="client.master" class="fa fa-star pull-right"></i>
                    </a>
                </li>
            </ul>
        </div>
        <div class="col-sm-9" ng-show="self.client !== null">
            <div class="panel">
                <div class="panel-body">
                    <ul class="nav nav-tabs">
                        <li class="active"><a href="#tab-client" data-toggle="tab" role="tab"><i class="fa fa-info fa-fw"></i> {{self.clientName}}</a></li>
                        <li><a href="#tab-database" data-toggle="tab" role="tab"><i class="fa fa-database fa-fw"></i> <?= $this->translate('client_tab_database') ?></a></li>
                        <li><a href="#tab-modules" data-toggle="tab" role="tab"><i class="fa fa-archive fa-fw"></i> <?= $this->translate('client_tab_modules') ?></a></li>
                        <li><a href="#tab-translation" data-toggle="tab" role="tab"><i class="fa fa-flag fa-fw"></i> <?= $this->translate('client_tab_translation') ?></a></li>
                        <li><a href="#tab-icons" data-toggle="tab" role="tab"><i class="fa fa-image fa-fw"></i> <?= $this->translate('client_tab_icons') ?></a></li>
                        <li ng-if="self.client.id"><a href="#tab-users" data-toggle="tab" role="tab"><i class="fa fa-users fa-fw"></i> <?= $this->translate('client_tab_users') ?></a></li>
                    </ul>

                    <br />

                    <form name="clientForm" ng-submit="self.saveClient()">

                        <div class="tab-content">
                            <div id="tab-client" class="tab-pane active">
                                <input type="hidden" name="id"
                                       ng-model="self.client.id" />

                                <div class="row">
                                    <div class="col-sm-6">
                                        <div class="form-group required">
                                            <label for="name"><?= $this->translate('client_field_name') ?></label>
                                            <div class="input-group">
                                                <input type="text" name="name" id="name" class="form-control" autocomplete="off" required
                                                       ng-model="self.client.name" />
                                                <span class="input-group-addon"><i class="fa fa-fw fa-tag"></i></span>
                                            </div>
                                            <field-errors field="name" errors="self.errors.fields"></field-errors>
                                        </div>

                                        <div class="form-group required">
                                            <label for="host"><?= $this->translate('client_field_host') ?></label>
                                            <div class="input-group">
                                                <span class="input-group-addon">http://</span>
                                                <input type="text" name="host" id="host" class="form-control" autocomplete="off" required
                                                       ng-model="self.client.host" />
                                                <span class="input-group-addon"><i class="fa fa-fw fa-laptop"></i></span>
                                            </div>
                                            <field-errors field="host" errors="self.errors.fields"></field-errors>
                                        </div>

                                        <div class="form-group required">
                                            <label for="key">
                                                <i class="fa fa-info-circle" data-toggle="tooltip" data-placement="top" title="<?= $this->translate('client_field_key_info', null, null, false) ?>"></i>
                                                <?= $this->translate('client_field_key') ?>
                                            </label>
                                            <div class="input-group">
                                                <input type="text" name="key" id="key" class="form-control" required autocomplete="off" pattern="[A-Za-z0-9]+"
                                                       ng-model="self.client.key" />
                                                <span class="input-group-addon"><i class="fa fa-fw fa-key"></i></span>
                                            </div>
                                            <field-errors field="key" errors="self.errors.fields"></field-errors>
                                        </div>

                                        <div class="form-group">
                                            <label for="theme"><?= $this->translate('client_field_theme') ?></label>
                                            <select class="form-control" name="theme" id="theme"
                                                    ng-model="self.client.theme">
                                                <option></option>
                                                <?php
                                                foreach ($this->themes as $theme) {
                                                    if ($theme !== '.' && $theme !== '..') {
                                                        echo '<option value="' . $theme . '">' . ucfirst($theme) . '</option>';
                                                    }
                                                }
                                                ?>
                                            </select>
                                            <field-errors field="theme" errors="self.errors.fields"></field-errors>
                                        </div>

                                        <div class="form-group">
                                            <label for="email"><?= $this->translate('client_field_email') ?></label>
                                            <div class="input-group">
                                                <input type="text" name="email" id="email" class="form-control" autocomplete="off"
                                                       ng-model="self.client.email" />
                                                <span class="input-group-addon"><i class="fa fa-fw fa-tag"></i></span>
                                            </div>
                                            <field-errors field="email" errors="self.errors.fields"></field-errors>
                                        </div>
                                    </div>

                                    <div class="col-sm-6">
                                        <div class="form-group">
                                            <label for="logo">
                                                <i class="fa fa-info-circle" data-toggle="tooltip" data-placement="top" title="<?= $this->translate('client_field_logo_info', null, null, false) ?>"></i>
                                                <?= $this->translate('client_field_logo') ?>
                                            </label>
                                            <br />
                                            <img ng-src="{{self.client.logo}}" ng-if="self.client.logo" style="max-height: 200px"/>
                                        </div>
                                    </div>
                                </div>

                                <br />

                                <div class="row">
                                    <div class="form-group col-xs-12">
                                        <button type="submit" class="btn btn-submit" ng-disabled="self.loading.remove || self.loading.save">
                                            <?= $this->icon('loading', '', ['ng-if' => 'self.loading.save']) ?>
                                            <?= $this->translate('form_button_save') ?>
                                        </button>
                                        <button type="button" class="btn btn-delete"
                                                ng-show="self.client.id" ng-disabled="self.loading.remove || self.loading.save"
                                                ng-click="self.removeClient(self.client)">
                                            <?= $this->icon('loading', '', ['ng-if' => 'self.loading.remove']) ?>
                                            <?= $this->translate('form_button_delete') ?>
                                        </button>
                                    </div>
                                </div>
                            </div>

                            <div id="tab-database" class="tab-pane">
                                <div class="row">
                                    <div class="form-group required col-sm-4">
                                        <label for="dbHost"><?= $this->translate('client_field_dbHost') ?></label>
                                        <div class="input-group">
                                            <input type="text" name="dbHost" id="dbHost" class="form-control" required autocomplete="off"
                                                   ng-model="self.client.dbHost" />
                                            <span class="input-group-addon"><i class="fa fa-server fa-fw"></i></span>
                                        </div>
                                        <field-errors field="dbHost" errors="self.errors.fields"></field-errors>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="form-group required col-sm-4">
                                        <label for="dbPort"><?= $this->translate('client_field_dbPort') ?></label>
                                        <div class="input-group">
                                            <input type="text" name="dbPort" id="dbPort" class="form-control" required autocomplete="off"
                                                   ng-model="self.client.dbPort" />
                                            <span class="input-group-addon"><i class="fa fa-info fa-fw"></i></span>
                                        </div>
                                        <field-errors field="dbPort" errors="self.errors.fields"></field-errors>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="form-group required col-sm-4">
                                        <label for="dbUser"><?= $this->translate('client_field_dbUser') ?></label>
                                        <div class="input-group">
                                            <input type="text" name="dbUser" id="dbUser" class="form-control" required autocomplete="off"
                                                   ng-model="self.client.dbUser" />
                                            <span class="input-group-addon"><i class="fa fa-user fa-fw"></i></span>
                                        </div>
                                        <field-errors field="dbUser" errors="self.errors.fields"></field-errors>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="form-group col-sm-4">
                                        <label for="dbPassword"><?= $this->translate('client_field_dbPassword') ?></label>
                                        <div class="input-group">
                                            <input type="text" name="dbPassword" id="dbPassword" class="form-control" autocomplete="off"
                                                   ng-model="self.client.dbPassword" />
                                            <span class="input-group-addon"><i class="fa fa-lock fa-fw"></i></span>
                                        </div>
                                        <field-errors field="dbPassword" errors="self.errors.fields"></field-errors>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="form-group required col-sm-4">
                                        <label for="dbName"><?= $this->translate('client_field_dbName') ?></label>
                                        <div class="input-group">
                                            <input type="text" name="dbName" id="dbName" class="form-control" required autocomplete="off"
                                                   ng-model="self.client.dbName" />
                                            <span class="input-group-addon"><i class="fa fa-database fa-fw"></i></span>
                                        </div>
                                        <field-errors field="dbName" errors="self.errors.fields"></field-errors>
                                    </div>
                                </div>

                                <br />

                                <div class="row">
                                    <div class="form-group col-xs-12">
                                        <button type="submit" class="btn btn-submit" ng-disabled="self.loading.remove || self.loading.save">
                                            <?= $this->icon('loading', '', ['ng-if' => 'self.loading.save']) ?>
                                            <?= $this->translate('form_button_save') ?>
                                        </button>
                                        <button type="button" class="btn btn-delete"
                                                ng-show="self.client.id" ng-disabled="self.loading.remove || self.loading.save"
                                                ng-click="self.removeClient(self.client)">
                                            <?= $this->icon('loading', '', ['ng-if' => 'self.loading.remove']) ?>
                                            <?= $this->translate('form_button_delete') ?>
                                        </button>
                                    </div>
                                </div>
                            </div>

                            <div id="tab-modules" class="tab-pane">
                                <div class="row">
                                    <div class="col-xs-12">
                                        <table class="table table-bordered table-hover">
                                            <thead>
                                                <tr>
                                                    <th><?= ucfirst($this->translate('module_entity')) ?></th>
                                                    <th><?= $this->translate('module_field_activable') ?></th>
                                                    <th>
                                                        <i class="fa fa-info-circle" data-toggle="tooltip" data-placement="top" data-title="<?= $this->translate('module_field_active_info', null, null, false) ?>"></i>
                                                        <?= $this->translate('module_field_active') ?>
                                                    </th>
                                                    <th class="actions-column"></th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                            <?php
                                                foreach ($this->modules as $i => $module) {
                                                    if(!$module->isRequired() || $module->getModuleConfiguration()) {
                                                        echo '<tr ng-init="self.modules[\'' . $module->getKey() . '\'] = {active: '.($module->isActive() ? 'true' : 'false').', activable: ' . ($module->isActivable() ? 'true' : 'false') . '}">';

                                                        echo '<td>' .  $this->translate($module->getKey() . '_module_title') . '</td>';
                                                        if (!$module->isRequired()) {
                                                            echo '<td>';
                                                                echo '<select class="form-control" ng-model="self.client.modules[\'' . $module->getKey() . '\'].activable" ng-options="item.value as item.label for item in [
                                                                    {
                                                                        value: true,
                                                                        label: \'Oui\'
                                                                    },
                                                                    {
                                                                        value: false,
                                                                        label: \'Non\'
                                                                    }
                                                                ]">';
                                                                echo '</select>';
                                                            echo '</td>';
                                                            echo '<td>';
                                                                echo '<select class="form-control" ng-model="self.client.modules[\'' . $module->getKey() . '\'].active" ng-options="item.value as item.label for item in [
                                                                            {
                                                                                value: true,
                                                                                label: \'Oui\'
                                                                            },
                                                                            {
                                                                                value: false,
                                                                                label: \'Non\'
                                                                            }
                                                                        ]"></select>';
                                                            echo '</td>';
                                                        } else {
                                                            echo '<td colspan="2"></td>';
                                                        }
                                                            echo '<td>';
                                                                echo $module->getModuleConfiguration() ? '<i class="fa fa-cogs pointer" ng-click="showConfig'.$i.' = !showConfig'.$i.'"></i>' : '';
                                                            echo '</td>';
                                                        echo '</tr>';
                                                        if ($module->getModuleConfiguration()) {
                                                            echo '<tr ng-show="showConfig'.$i.'">';
                                                                echo '<td colspan="4">';
                                                                foreach ($module->getModuleConfiguration() as $parameterKey => $parameter) {
                                                                    echo '<div class="form-group">';
                                                                        echo '<label>' . $this->translate($parameter['text']) . '</label>';
                                                                        switch($parameter['type']) {
                                                                            case 'text':
                                                                                echo '<input type="text" class="form-control" ng-model="self.client.modules[\'' . $module->getKey() . '\'].configuration[\'' . $parameterKey . '\']"/>';
                                                                                break;
                                                                            case 'unique':
                                                                                echo '<select class="form-control" ng-model="self.client.modules[\'' . $module->getKey() . '\'].configuration[\'' . $parameterKey . '\']">';
                                                                                    foreach ($parameter['options'] as $option) {
                                                                                        echo '<option value="' . $option['value'] . '">' . $this->translate($option['text']) . '</option>';
                                                                                    }
                                                                                echo '<select>';
                                                                                break;
                                                                            case 'multiple':
                                                                                echo '<select multiple class="form-control" ng-model="self.client.modules[\'' . $module->getKey() . '\'].configuration[\'' . $parameterKey . '\']">';
                                                                                    foreach ($parameter['options'] as $option) {
                                                                                        echo '<option value="' . $option['value'] . '">' . $this->translate($option['text']) . '</option>';
                                                                                    }
                                                                                echo '<select>';
                                                                                break;
                                                                            case 'boolean':
                                                                                echo '<div class="checkbox">';
                                                                                    echo '<label>';
                                                                                        echo '<input type="checkbox" ng-model="self.client.modules[\'' . $module->getKey() . '\'].configuration[\'' . $parameterKey . '\']"/>';
                                                                                        echo 'Activer ?';
                                                                                    echo '</label>';
                                                                                echo '</div>';
                                                                                break;
                                                                        }
                                                                    echo '</div>';
                                                                }
                                                                echo '</td>';
                                                            echo '</tr>';
                                                        }
                                                    }
                                                }
                                            ?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>

                                <br />

                                <div class="row">
                                    <div class="form-group col-xs-12">
                                        <button type="submit" class="btn btn-submit" ng-disabled="self.loading.remove || self.loading.save">
                                            <?= $this->icon('loading', '', ['ng-if' => 'self.loading.save']) ?>
                                            <?= $this->translate('form_button_save') ?>
                                        </button>
                                        <button type="button" class="btn btn-delete"
                                                ng-show="self.client.id" ng-disabled="self.loading.remove || self.loading.save"
                                                ng-click="self.removeClient(self.client)">
                                            <?= $this->icon('loading', '', ['ng-if' => 'self.loading.remove']) ?>
                                            <?= $this->translate('form_button_delete') ?>
                                        </button>
                                    </div>
                                </div>
                            </div>

                            <div id="tab-translation" class="tab-pane">
                                <div class="row">
                                    <div class="col-xs-12">
                                        <table class="table table-bordered table-hover">
                                            <tbody>
                                            <?php
                                                foreach ($this->translations as $key => $value) {
                                                    echo '<tr ng-init="self.translations[\'' . $key . '\'] = \''. addslashes($value) .'\'">';
                                                        echo '<td class="fit-content">' .  $key . '</td>';
                                                        echo '<td class="form-horizontal">';
                                                            echo '<input type="text" class="form-control" ng-model="self.client.translations[\'' . $key . '\']" />';
                                                        echo '</td>';
                                                    echo '</tr>';
                                                }
                                            ?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>

                                <br />

                                <div class="row">
                                    <div class="form-group col-xs-12">
                                        <button type="submit" class="btn btn-submit" ng-disabled="self.loading.remove || self.loading.save">
                                            <?= $this->icon('loading', '', ['ng-if' => 'self.loading.save']) ?>
                                            <?= $this->translate('form_button_save') ?>
                                        </button>
                                        <button type="button" class="btn btn-delete"
                                                ng-show="self.client.id" ng-disabled="self.loading.remove || self.loading.save"
                                                ng-click="self.removeClient(self.client)">
                                            <?= $this->icon('loading', '', ['ng-if' => 'self.loading.remove']) ?>
                                            <?= $this->translate('form_button_delete') ?>
                                        </button>
                                    </div>
                                </div>
                            </div>

                            <div id="tab-icons" class="tab-pane">
                                <div class="row">
                                    <div class="col-xs-12">
                                        <table class="table table-bordered table-hover">
                                            <tbody>
                                            <?php
                                                foreach ($this->icons as $icon => $iconData) {
                                                    echo '<tr ng-init="self.icons[\'' . $icon . '\'] = '. str_replace('"', '\'', json_encode($iconData)).'">';
                                                        echo '<td class="fit-content">' .  $icon . '</td>';
                                                        echo '<td class="form-horizontal">';
                                                            echo 'Type : <select class="form-control" ng-model="self.client.icons[\'' . $icon . '\'].type" ng-options="item.value as item.label for item in [
                                                                    {
                                                                        value: \'css\',
                                                                        label: \'css\'
                                                                    },
                                                                ]"></select>';
                                                            echo 'Element : <input type="text" class="form-control" ng-model="self.client.icons[\'' . $icon . '\'].element" />';
                                                            echo 'Classes : <input type="text" class="form-control" ng-model="self.client.icons[\'' . $icon . '\'].classes" />';
                                                        echo '</td>';
                                                    echo '</tr>';
                                                }
                                            ?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>

                                <br />

                                <div class="row">
                                    <div class="form-group col-xs-12">
                                        <button type="submit" class="btn btn-submit" ng-disabled="self.loading.remove || self.loading.save">
                                            <?= $this->icon('loading', '', ['ng-if' => 'self.loading.save']) ?>
                                            <?= $this->translate('form_button_save') ?>
                                        </button>
                                        <button type="button" class="btn btn-delete"
                                                ng-show="self.client.id" ng-disabled="self.loading.remove || self.loading.save"
                                                ng-click="self.removeClient(self.client)">
                                            <?= $this->icon('loading', '', ['ng-if' => 'self.loading.remove']) ?>
                                            <?= $this->translate('form_button_delete') ?>
                                        </button>
                                    </div>
                                </div>
                            </div>

                            <div id="tab-users" class="tab-pane">
                                <div class="input-group">
                                    <input type="text" autocomplete="off" class="form-control" placeholder="<?= $this->translate('search', null, null, false) ?>"
                                           ng-model="userQuery" />
                                    <span class="input-group-addon"><i class="fa fa-fw fa-search"></i></span>
                                </div>

                                <br />

                                <table class="table table-bordered table-condensed table-hover">
                                    <thead>
                                        <tr>
                                            <th></th>
                                            <th>
                                                #
                                            </th>
                                            <th>
                                                Utilisateur
                                            </th>
                                            <th>
                                                Login
                                            </th>
                                            <th>
                                                Email
                                            </th>
                                            <th>
                                                Rôle
                                            </th>
                                        </tr>
                                    </thead>
                                    <tr ng-repeat="user in self.users | filter:userQuery">
                                        <td class="text-center">
                                            <a title="Se connecter en tant que" class="pointer" ng-click="self.loginAs(user)">
                                                <i class="fa fa-sign-in"></i>
                                            </a>
                                        </td>
                                        <td>
                                            {{user.id}}
                                        </td>
                                        <td>
                                            {{user.name}}
                                        </td>
                                        <td>
                                            {{user.login}}
                                        </td>
                                        <td>
                                            {{user.email}}
                                        </td>
                                        <td>
                                            {{user.role}}
                                        </td>
                                    </tr>
                                </table>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

</div>

<?php
    $this->angular('js/src/admin/client/service/client.js');
    $this->angular('js/src/admin/client/controller/client.js');
